unit gls1c8_1;
interface
uses
  IniFiles,
  ActiveX, ShlObj,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Buttons, StdCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    Edit_FN_v8ib_lst: TEdit;
    GroupBox1: TGroupBox;
    Panel2: TPanel;
    SpeedButton2: TSpeedButton;
    Memo1: TMemo;
    Panel3: TPanel;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;



implementation

{$R *.DFM}


//*******************************************************************
function Get_Path_To_SpecialFolder(CSIDL : cardinal) : string;
//    . 
//  Windows.
//  http://www.swissdelphicenter.ch/en/showcode.php?id=233
var
  Allocator: IMalloc;
  SpecialDir: PItemIdList;
  FBuf: array[0..MAX_PATH] of Char;
  PerDir: string;
begin
  Result:='';
  if SHGetMalloc(Allocator) = NOERROR then begin
    SHGetSpecialFolderLocation(Form1.Handle, CSIDL_APPDATA, SpecialDir);
    SHGetPathFromIDList(SpecialDir, @FBuf[0]);
    Allocator.Free(SpecialDir);
    Result:=string(FBuf);
  end;
end;
//*******************************************************************



//*******************************************************************
//*******************************************************************
//*******************************************************************
//   :
//http://politics.delphimaster.ru/cgi-bin/forum.pl?id=1188308666&n=0
function UTF8ToStr(Value: String): String;
{Convert string from UTF-8 format into ASCII}
var
 buffer: Pointer;
 BufLen: LongWord;
begin
 BufLen := Length(Value) + 4;
 GetMem(buffer, BufLen);
 FillChar(buffer^, BufLen, 0);
 MultiByteToWideChar(CP_UTF8, 0, @Value[1], BufLen - 4, buffer, BufLen);
 Result := WideCharToString(buffer);
 FreeMem(buffer, BufLen);
end;

function UTF8ToStrSmart(Value: String): String;
{Convert string from UTF-8 format mixed with standart ASCII symbols($00..$7f)}
var
 Digit: String;
 i: Word;
 HByte: Byte;
 Len: Byte;
begin
 Result := '';
 Len := 0;
 if Value = '' then Exit;
 for i := 1 to Length(Value) do
 begin
   if Len > 0 then
   begin
     Digit := Digit + Value[i];
     Dec(Len);
     if Len = 0 then
       Result := Result + UTF8ToStr(Digit);
   end else
   begin
     HByte := Ord(Value[i]);
     if HByte in [$00..$7f] then       //Standart ASCII chars
       Result := Result + Value[i]
     else begin
       //Get length of UTF-8 char
       if HByte and $FC = $FC then
         Len := 6
       else if HByte and $F8 = $F8 then
         Len := 5
       else if HByte and $F0 = $F0 then
         Len := 4
       else if HByte and $E0 = $E0 then
         Len := 3
       else if HByte and $C0 = $C0 then
         Len := 2
       else begin
         Result := Result + Value[i];
         Continue;
       end;
       Dec(Len);
       Digit := Value[i];
     end;
   end;
 end;
end;
//*******************************************************************
//*******************************************************************
//*******************************************************************


function UTF8_to_Str_List(List : TStrings): integer;
Var
  i : integer;
  Sx : string;
begin
  Result:=0;
  if List<>NIL then begin
     if List.Count>0 then begin
        for i:=0 to (List.Count-1) do
         begin
           Sx:=List[i];
           Sx:=UTF8ToStrSmart(Sx);
           List[i]:=Sx;
        end;
     end;
  end;
end;


procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  //      : Application Data
  Edit_FN_v8ib_lst.Text:=Get_Path_To_SpecialFolder(CSIDL_APPDATA)+'\1C\1Cv8\v8ib.lst';
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  Memo1.Lines.Clear;
  if FileExists(Edit_FN_v8ib_lst.Text) then begin
     Memo1.Lines.LoadFromFile(Edit_FN_v8ib_lst.Text);
  end
  else begin
    ShowMessage('   !');
  end;
end;


procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  UTF8_to_Str_List(Memo1.Lines);
end;


procedure TForm1.SpeedButton4Click(Sender: TObject);
Var
  Sx : string;
  i : integer;
  List : TStrings;
begin
  if Memo1.Lines.Count>0 then begin
     List := TStringList.Create;
     TRY
      Sx:=Trim(Memo1.Lines[0]);
      if length(Sx)>0 then begin
         if Sx[1]<>'[' then System.Delete(Sx,1,1);
         Memo1.Lines[0]:=Trim(Sx);
      end;

      for i:=0 to (Memo1.Lines.Count-1) do
       begin
        Sx:=Trim(Memo1.Lines[i]);
        if length(Sx)>0 then begin
           if Sx[1]='[' then begin
              System.Delete(Sx,1,1);
           end;
           if length(Sx)>0 then begin
              if Sx[length(Sx)]=']' then begin
                 System.Delete(Sx,length(Sx),1);
                 if length(Sx)>0 then begin
                    List.Add(Sx);
                 end;
              end;
           end;
        end;
      end;

      Memo1.Lines.Assign(List);

     FINALLY
       if List<>NIL then begin
          List.Clear;
          List.Free;
          List:=nil;
       end;
     END;
  end;
end;


end.




